using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data;
using System.Configuration;
using System.Web.Security;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;
using Telerik.Web.UI;

public partial class Default : System.Web.UI.Page 
{
    private HttpCookie myCookie;

    protected void Page_Load(object sender, EventArgs e)
    {
        //lblTest.Text = System.AppDomain.CurrentDomain.BaseDirectory.ToString();
        if (!IsPostBack)
        {
            GetandSetRadTabStrip1LocationFromCookie(RadTabStrip1, RadMultiPage1);
        }
    }
    protected void Page_PreRender(object sender, EventArgs e)
    {
        SetRadTabStrip1LocationCookie(RadTabStrip1);
    }
    #region TabStrip Functions
    /// ********************************
    ///  ****** Tabstrip functions ******
    ///  ********************************
    ///  1. Tab Strip Functions are to handle keeping state of a tabstrip control (an it's associated multipage)
    ///  2. Functionality is handled by use of cookies. (but I can see several other simple approaches that could 
    ///     substitute, such as a db lookup, viewstate.
    ///  3. The two functions (GetandSetRadTabStrip1LocationFromCookie), if your tabstrip has an accompanied
    ///     multipage control, pass it in and it'll set it as well.
    /// <summary>
    /// function gets (if available) the "SFCC" TabStripControlName Cookie and set the current tabs.
    /// </summary>
    /// <param name="TabStripControl"></param>
    private void GetandSetRadTabStrip1LocationFromCookie(RadTabStrip TabStripControl)
    {
        try
        {
            if (HttpContext.Current.Request.Cookies["SFCC" + TabStripControl.ID] != null)
            {
                myCookie = HttpContext.Current.Request.Cookies["SFCC" + TabStripControl.ID];
                string strTopLevel = myCookie["TopLevel"].ToString().TrimEnd();
                string strInnerMostSelectedTab = myCookie["InnerMostSelectedTab"].ToString().TrimEnd();
                if (strTopLevel != null && strTopLevel != "None")
                {   // values exist, now set.
                    TabStripControl.FindTabByText(strTopLevel).Selected = true;
                }
                else
                {   // values don't exist.  set first tab.
                    lblError.Text = "Got here, MAIN tab should be selected";
                    //int intIndex = 0;
                    //intIndex = TabStripControl.SelectedIndex;
                    //RadMultiPage1.SelectedIndex = 0;
                }
                if (strInnerMostSelectedTab != null && strInnerMostSelectedTab != "None")
                {
                    TabStripControl.FindTabByText(strInnerMostSelectedTab).Selected = true;
                }
            }
        }
        catch { }
    }
    /// <summary>
    /// function gets (if available) the "SFCC" TabStripControlName Cookie and set the current tabs
    /// ** Overload Function ** sets to attached radmultipage control. **
    /// </summary>
    /// <param name="TabStripControl"></param>
    /// <param name="MultiPageControl"></param>
    private void GetandSetRadTabStrip1LocationFromCookie(RadTabStrip TabStripControl, RadMultiPage MultiPageControl)
    {
        try
        {
            if (HttpContext.Current.Request.Cookies["SFCC" + TabStripControl.ID] != null)
            {
                myCookie = HttpContext.Current.Request.Cookies["SFCC" + TabStripControl.ID];
                string strTopLevel = myCookie["TopLevel"].ToString().TrimEnd();
                string strInnerMostSelectedTab = myCookie["InnerMostSelectedTab"].ToString().TrimEnd();
                if (strTopLevel != null && strTopLevel != "None")
                {   // values exist, now set.
                    TabStripControl.FindTabByText(strTopLevel).Selected = true;
                }
                else
                {   // values don't exist.  set first tab.
                    lblError.Text = "Got here, MAIN tab should be selected";
                    //int intIndex = 0;
                    //intIndex = TabStripControl.SelectedIndex;
                    //RadMultiPage1.SelectedIndex = 0;
                } if (strInnerMostSelectedTab != null && strInnerMostSelectedTab != "None")
                {
                    string strPageViewID;
                    TabStripControl.FindTabByText(strInnerMostSelectedTab).Selected = true;
                    if (TabStripControl.FindTabByText(strInnerMostSelectedTab).PageViewID != null)
                    {
                        strPageViewID = TabStripControl.FindTabByText(strInnerMostSelectedTab).PageViewID.ToString().Trim();
                        MultiPageControl.FindPageViewByID(strPageViewID).Selected = true;
                    }
                }
            }
        }
        catch { }
    }
    /// <summary>
    /// function sets the "SFCC" + TabStripControlName Cookie, 
    /// values (TopLevel) and (InnerMostSelectedTab) are set based on the current tabs.
    /// </summary>
    /// <param name="TabStripControl"></param>
    private void SetRadTabStrip1LocationCookie(RadTabStrip TabStripControl)
    {
        string strTabSelected;
        string strChildIndexSelected;
        try
        {
            // Get top tabname and innsermost tab name.
            strTabSelected = TabStripControl.SelectedTab.Text;
            strChildIndexSelected = TabStripControl.InnermostSelectedTab.Text;
        }
        catch
        {
            strTabSelected = "None";
            strChildIndexSelected = "None";
        }
        try
        {
            if (HttpContext.Current.Request.Cookies["SFCC" + TabStripControl.ID] != null)
            {
                myCookie = HttpContext.Current.Request.Cookies["SFCC" + TabStripControl.ID];
                myCookie.Values["TopLevel"] = strTabSelected;
                myCookie.Values["InnerMostSelectedTab"] = strChildIndexSelected;
            }
            else
            {
                // No cookie, First Visit Default Skin and Default Telerik. (These should be the same)
                myCookie = new HttpCookie("SFCC" + TabStripControl.ID);
                myCookie.Values["TopLevel"] = strTabSelected;
                myCookie.Values["InnerMostSelectedTab"] = strChildIndexSelected;
            }
            myCookie.Expires = DateTime.Now.AddDays(Convert.ToInt32(1));
            HttpContext.Current.Response.Cookies.Add(myCookie);
        }
        catch { /* this should never happen */}
    }
    #endregion
}
